import { createContext, forwardRef, Children, isValidElement, cloneElement, Suspense, createElement, useReducer, useEffect, useContext } from 'react';
import { getMergedConfig } from '@plume-ui-react/core';
import { getLightenColor, getContrastColor } from '@plume-ui-react/color-utils';
import { jsx } from 'react/jsx-runtime';
import { Button } from '@plume-ui-react/button';
import { Spinner } from '@plume-ui-react/spinner';
import { lazyLoadContent } from '@plume-ui-react/lazy-utils';

var x=(e,{type:r,payload:t})=>{switch(r){case"SET_ACTIVE_TAB_INDEX":return {...e,index:t};case"SET_CONFIG":return {...e,...t};default:return e}};var a={tabsPadding:".5rem .75rem",tabsBorderWidth:"2px",tabsBorderRadius:".5rem",tabs:"_tabs_c879z_6",horizontal:"_horizontal_c879z_11",vertical:"_vertical_c879z_15",left:"_left_c879z_19",center:"_center_c879z_23",right:"_right_c879z_27",sm:"_sm_c879z_31",md:"_md_c879z_36",lg:"_lg_c879z_40",underline:"_underline_c879z_45",tablist:"_tablist_c879z_55",tab:"_tab_c879z_6",active:"_active_c879z_85",rounded:"_rounded_c879z_96",enclosed:"_enclosed_c879z_103",segment:"_segment_c879z_134",panel:"_panel_c879z_154"};var y=createContext(void 0);function g({config:e,children:r}){let[t,o]=useReducer(x,e),s=t.alignment!=="left"||t.isStyled?a[t.alignment]:"",n=t.isStyled?a[t.size]:"",d=t.isStyled?a[t.variant]:"";useEffect(()=>{o({type:"SET_CONFIG",payload:e});},[e.alignment,e.colorScheme,e.index,e.isLazy,e.size,e.variant]);let i=l=>{o({type:"SET_ACTIVE_TAB_INDEX",payload:l});};return jsx(y.Provider,{value:{...t,alignmentClass:s,sizeClass:n,variantClass:d,setActiveTabIndex:i},children:r})}var c=()=>{let e=useContext(y);if(!e)throw new Error("useTabs must be used within a TabsProvider");return e};var $=(e,r,t,o)=>({"--tabs-scheme":e,"--tabs-background-color":t,"--tabs-text-color":r,...o??{}}),h=forwardRef(({children:e,colorScheme:r,style:t,onChange:o,index:s=0,alignment:n="left",className:d="",orientation:i="horizontal",size:l="md",variant:_="underline",isLazy:m=!1,...T},u)=>{let b=r&&getMergedConfig().colors[r]||"#d3d3d3",f=getLightenColor(b,20),p=getContrastColor(b),z=_!=="unstyled",A=`${i!=="horizontal"||z?a[i]:""} ${z?a.tabs:""} ${d}`.trim();return jsx(g,{config:{index:s,alignment:n,colorScheme:r,isLazy:m,isStyled:z,size:l,variant:_,onChange:o},children:jsx("div",{className:A,ref:u,style:$(b,p,f,t),...T,children:e})})});h.displayName="Tabs";var C=forwardRef(({children:e,...r},t)=>{let{index:o,alignmentClass:s,isStyled:n,variantClass:d}=c();return jsx("div",{"aria-label":"Tab List",className:`${n?a.tablist:""} ${d} ${s}`.trim(),ref:t,role:"tablist",...r,children:Children.map(e,(i,l)=>isValidElement(i)?cloneElement(i,{index:l,isActive:l===o}):i)})});C.displayName="TabList";var L=forwardRef(({label:e,isActive:r,disabled:t,isExtraContentRight:o,extraContent:s,index:n,children:d,className:i=""},l)=>{let{alignmentClass:_,isStyled:m,sizeClass:T,setActiveTabIndex:u,onChange:b}=c(),f=()=>{let p=n||0;b&&b(p),u(p);};return jsx(Button,{"aria-selected":r,className:`${m?a.tab:""} ${_} ${T} ${r&&m?a.active:""} ${i}`.trim(),disabled:t,iconLeft:o?null:s,iconRight:o?s:null,index:n,label:e??"",onClick:f,ref:l,role:"tab",variant:"unstyled",children:d??null},e)});L.displayName="Tab";var S=forwardRef(({children:e,...r},t)=>{let{index:o}=c();return jsx("div",{ref:t,...r,children:Children.map(e,(s,n)=>n===o&&s)})});S.displayName="TabPanels";var E=forwardRef(({children:e},r)=>{let{colorScheme:t,isLazy:o,isStyled:s}=c(),n=o?lazyLoadContent(e):e;return jsx("div",{"aria-label":"Tab Panel",className:s?a.panel:"",ref:r,role:"tabpanel",children:o?jsx(Suspense,{fallback:jsx(Spinner,{colorScheme:t}),children:createElement(n)}):n})});E.displayName="TabPanel";

export { L as Tab, C as TabList, E as TabPanel, S as TabPanels, h as Tabs };
